#include "premiers.h"
#include <math.h>

#define NOM_BD "premiers.bd"

int main(int argc, char *argv[]) {
  unsigned long n,p;
  if(argc > 1) {
    sscanf(argv[1],"%lu",&n);
  } else {
    printf("aucune entier en entrée...");
    exit(1);
  }
  FILE *bd;
  bd = fopen(NOM_BD,"rb");
  if (!bd) {
    printf("La base de donnés n'a pas encore étée faite, executer update_premiers.\n");
    exit(1);
  }
  fread(&p,sizeof(unsigned long),1,bd);
  if(p < sqrt(n)) {
  }
  printf("Factorisation : ");
  unsigned int e;
  p = 2;
  while (n > 1 && !feof(bd)) {
    if (n%p == 0) {
      e = 0;
      do {
        e++;
        n /= p;
      } while (n%p == 0);
      printf("%lu",p);
      if (e > 1) {
        printf("^%u ",e);
      } else {
        printf(" ");
      }
    }
    fread(&p, sizeof(unsigned long), 1, bd);
  }
  rewind(bd);
  fread(&p,sizeof(unsigned long),1,bd);
  fclose(bd);
  if (n > 1) {
    if (n <= p*p) {
      printf("%lu",n);
    } else {
      printf("...\nLa base de donnée n'a pas été assez pour factoriser.\nIl reste à factoriser : %lu\nExecuter update_premiers N, avec N >= %.0lf.",n,sqrt(n));
    }
  }
  printf("\n");
}
